	.file	"routines.c"
@ GNU C version 3.3.2 (arm-thumb-elf)
@	compiled by GNU C version 3.3.1 (cygming special).
@ GGC heuristics: --param ggc-min-expand=100 --param ggc-min-heapsize=131072
@ options passed:  -fpreprocessed -mthumb-interwork -mlong-calls
@ -auxbase-strip -O2 -Wall -fverbose-asm
@ options enabled:  -fdefer-pop -fomit-frame-pointer
@ -foptimize-sibling-calls -fcse-follow-jumps -fcse-skip-blocks
@ -fexpensive-optimizations -fthread-jumps -fstrength-reduce -fpeephole
@ -fforce-mem -ffunction-cse -fkeep-static-consts -fcaller-saves
@ -freg-struct-return -fgcse -fgcse-lm -fgcse-sm -floop-optimize
@ -fcrossjumping -fif-conversion -fif-conversion2 -frerun-cse-after-loop
@ -frerun-loop-opt -fdelete-null-pointer-checks -fschedule-insns
@ -fschedule-insns2 -fsched-interblock -fsched-spec -fbranch-count-reg
@ -freorder-blocks -freorder-functions -fcprop-registers -fcommon
@ -fverbose-asm -fgnu-linker -fregmove -foptimize-register-move
@ -fargument-alias -fstrict-aliasing -fmerge-constants
@ -fzero-initialized-in-bss -fident -fpeephole2 -fguess-branch-probability
@ -fmath-errno -ftrapping-math -mapcs -mapcs-frame -mapcs-32 -msoft-float
@ -mthumb-interwork -mlong-calls

	.global	pOAM
	.data
	.align	2
	.type	pOAM, %object
	.size	pOAM, 4
pOAM:
	.word	117440512
	.global	MemVideo
	.align	2
	.type	MemVideo, %object
	.size	MemVideo, 4
MemVideo:
	.word	100663296
	.global	Palette
	.align	2
	.type	Palette, %object
	.size	Palette, 4
Palette:
	.word	83886080
	.global	PaletteObj
	.align	2
	.type	PaletteObj, %object
	.size	PaletteObj, 4
PaletteObj:
	.word	83886592
	.global	FrontBuffer
	.align	2
	.type	FrontBuffer, %object
	.size	FrontBuffer, 4
FrontBuffer:
	.word	100663296
	.global	BackBuffer
	.align	2
	.type	BackBuffer, %object
	.size	BackBuffer, 4
BackBuffer:
	.word	100704256
	.global	CompteurScanline
	.align	2
	.type	CompteurScanline, %object
	.size	CompteurScanline, 4
CompteurScanline:
	.word	67108870
	.text
	.align	2
	.global	AttendVSync
	.type	AttendVSync, %function
AttendVSync:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	@ link register save eliminated.
	ldr	r1, .L8
	@ lr needed for prologue
.L2:
	ldr	r2, [r1, #0]	@  CompteurScanline
	ldrh	r3, [r2, #0]
	cmp	r3, #159
	bhi	.L2
.L5:
	ldrh	r3, [r2, #0]
	cmp	r3, #159
	bls	.L5
	bx	lr
.L9:
	.align	2
.L8:
	.word	CompteurScanline
	.size	AttendVSync, .-AttendVSync
	.align	2
	.global	BasculePages
	.type	BasculePages, %function
BasculePages:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	@ link register save eliminated.
	mov	r0, #67108864
	ldr	r3, [r0, #0]
	tst	r3, #16
	ldrne	r3, .L14
	ldreq	r3, .L14+4
	ldrne	r2, [r0, #0]
	ldreq	r2, [r0, #0]
	ldrne	r1, [r3, #0]	@  BackBuffer
	ldreq	r1, [r3, #0]	@  FrontBuffer
	ldr	r3, .L14+8
	bicne	r2, r2, #16
	orreq	r2, r2, #16
	@ lr needed for prologue
	str	r2, [r0, #0]
	str	r1, [r3, #0]	@  MemVideo
	bx	lr
.L15:
	.align	2
.L14:
	.word	BackBuffer
	.word	FrontBuffer
	.word	MemVideo
	.size	BasculePages, .-BasculePages
	.align	2
	.global	CopieDMA
	.type	CopieDMA, %function
CopieDMA:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	@ link register save eliminated.
	mov	ip, #67108864
	cmp	r3, #-2080374784	@  mode
	cmpne	r3, #-2147483648	@  mode
	orr	r2, r2, r3	@  nbval,  mode
	streq	r0, [ip, #212]	@  source
	@ lr needed for prologue
	streq	r1, [ip, #216]	@  dest
	streq	r2, [ip, #220]
	bx	lr
	.size	CopieDMA, .-CopieDMA
	.align	2
	.global	MemMove16bits
	.type	MemMove16bits, %function
MemMove16bits:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	stmfd	sp!, {r4, r5, lr}
	mov	r3, r2, asl #1	@  nbval
	cmp	r0, r1	@  dest,  source
	mov	ip, r2	@  nbval
	add	r2, r0, r3	@  dest
	add	r3, r1, r3	@  source
	mov	r5, #67108864
	orr	lr, ip, #-2147483648	@  reg_dma,  nbval
	sub	r3, r3, #2
	orrhi	lr, ip, #-2147483648	@  reg_dma,  nbval
	strhi	r3, [r5, #212]
	sub	r2, r2, #2
	orrhi	lr, lr, #10485760	@  reg_dma,  reg_dma
	mov	r3, #67108864
	mov	r4, r5
	strls	r1, [r5, #212]	@  source
	strhi	r2, [r5, #216]
	strls	r0, [r5, #216]	@  dest
	str	lr, [r3, #220]	@  reg_dma
	ldmfd	sp!, {r4, r5, lr}
	bx	lr
	.size	MemMove16bits, .-MemMove16bits
	.align	2
	.global	MemSet
	.type	MemSet, %function
MemSet:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	@ link register save eliminated.
	orr	r2, r2, r3	@  nbval,  mode
	mov	ip, #67108864
	cmp	r3, #-2080374784	@  mode
	cmpne	r3, #-2147483648	@  mode
	orr	r2, r2, #16777216
	streq	r0, [ip, #212]	@  source
	@ lr needed for prologue
	streq	r1, [ip, #216]	@  dest
	streq	r2, [ip, #220]
	bx	lr
	.size	MemSet, .-MemSet
	.align	2
	.global	CopieDMA0
	.type	CopieDMA0, %function
CopieDMA0:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	@ link register save eliminated.
	mov	ip, #67108864
	cmp	r3, #-2080374784	@  mode
	cmpne	r3, #-2147483648	@  mode
	orr	r2, r2, r3	@  nbval,  mode
	streq	r0, [ip, #176]	@  source
	@ lr needed for prologue
	streq	r1, [ip, #180]	@  dest
	streq	r2, [ip, #184]
	bx	lr
	.size	CopieDMA0, .-CopieDMA0
	.align	2
	.global	InitTimers
	.type	InitTimers, %function
InitTimers:
	@ Function supports interworking.
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 0, uses_anonymous_args = 0
	@ link register save eliminated.
	mov	r1, #260
	mov	r2, #67108864
	add	r1, r1, #67108866
	mov	r0, #0
	add	r2, r2, #260
	strh	r0, [r1, #0]	@ movhi 
	strh	r0, [r2, #0]	@ movhi 
	ldrh	r3, [r1, #0]
	bic	r3, r3, #3
	strh	r3, [r1, #0]	@ movhi 
	ldrh	r2, [r1, #0]
	orr	r2, r2, #2
	strh	r2, [r1, #0]	@ movhi 
	ldrh	r3, [r1, #0]
	orr	r3, r3, #128
	@ lr needed for prologue
	strh	r3, [r1, #0]	@ movhi 
	bx	lr
	.size	InitTimers, .-InitTimers
	.comm	pRoutineLointaine, 4, 32
	.comm	pFctLointaine, 4, 32
	.comm	ligne2, 4, 32
	.comm	gblCurs, 4, 32
	.ident	"GCC: (GNU) 3.3.2"
