//Support multi-fichiers source
#ifndef VARS_H
    #define VARS_H

    #include <mygba.h>
    
    #define REG_KEYS *(volatile unsigned long*) 0x4000130

    #define REG_TOUCHES (~(REG_KEYS) & 0x3FF)
    #define TOUCHE_A 0x0001
    #define TOUCHE_B 0x0002
    #define TOUCHE_SELECT 0x0004
    #define TOUCHE_START 0x0008
    #define TOUCHE_DROITE 0x0010
    #define TOUCHE_GAUCHE 0x0020
    #define TOUCHE_HAUT 0x0040
    #define TOUCHE_BAS 0x0080
    #define TOUCHE_R 0x0100
    #define TOUCHE_L 0x0200
    #undef RGB
    #define RGB(r,g,b)          ((r)+((g)<<5)+((b)<<10))
    #define IN_IWRAM __attribute__ ((section (".iwram")))

    unsigned short *MemVideo = (unsigned short*)0x6000000;
    extern long var;                    //Je l'ai dfinie comme tant en EWRAM
    long var_c;                         //Place en IWRAM par le compilateur

    extern void LaRoutineDeLaMort(void);
    extern void EffetCouleur(void);
    extern void DessinePixel(u32 x, u32 y, u32 couleur);

#endif /* VARS_H */


