//Chaque charblock fait 16 ko (il contient 512 mosaques 4 bits par exemple)
#define CharBaseBlock(n) ((void*)(((n)*0x4000)+0x6000000))
//Chaque screenblock fait 2 ko (il contient une map texte de 256x256 par exemple)
#define ScreenBaseBlock(n) ((void*)(((n)*0x0800)+0x6000000))

//Pointeur sur la mmoire de la palette (256 couleurs 16 bits)
unsigned short *Palette = (unsigned short*)0x5000000;
//La palette des objets est situe ailleurs, permettant 256 couleurs supplmentaires
unsigned short *PaletteObj = (unsigned short*)0x5000200;

//Indique la ligne en train d'tre dessine par le contrleur graphique.
volatile unsigned short *CompteurScanline = (volatile unsigned short *)0x4000006;

//Attend la VSync, c--d que le contrleur graphique a fini de dessiner les 160 lignes de l'cran.
void AttendVSync()     {
    while (*CompteurScanline>=160);
    while (*CompteurScanline<160);
}



